/***********************
* Adobe Edge Animate コンポジションアクション
*
* このファイルを編集する際には注意が必要です。必ず関数シグニチャと
* 「Edge」で始まるコメントを保持して、 Adobe Edge 内からこれらのアクションを
* 操作可能な状態にしておいてください。 
*
***********************/
(function($, Edge, compId){
var Composition = Edge.Composition, Symbol = Edge.Symbol; // よく使用する Edge クラスのエイリアス

   //Edge symbol: 'stage'
   (function(symbolName) {
      
      
      

      Symbol.bindSymbolAction(compId, symbolName, "creationComplete", function(sym, e) {
         //ready to drang and drop, sorry for my spaghetti-code ;p
         
         //get jQuery handle from {Symbol|jQuery Handle|String}
         Edge.getJQHandle = function(target){
           var handle;
           if(target instanceof Symbol){
             handle = target.getSymbolElement();  //case Symbol
           }else if(parseInt(target.length)>1){
             handle = target;                     //case jQuery handle
           }else{
             handle = $(target);                  //case else(suppose string :p)
           }
           return handle;
         }
         
         //extend Edge's Symbol method
         Symbol.prototype.draggableX = function(opt){
         	Edge.getJQHandle(this).draggableX(opt);
         };
         
         //extend jQuery func
         //get CSS left
         $.fn.getLeftPx = function(){
           var left = this.css("left");
           var isPx = left.indexOf("%")==-1 && !isNaN(parseInt(left));
           if(isPx==true){
             left = parseInt(left);
           }else{
             //case of use "%" or not use "left";
             var oldLeft = this.offset().left;
             this.css("left","0px");
             left =  oldLeft-this.offset().left;
             this.css("left",oldLeft+"px");
           }
           return left;
         };
         //add draggable feature
         $.fn.draggableX = function(opt){
           var opt = opt||{};
           opt.target=(opt.target)?Edge.getJQHandle(opt.target):null;
           var ddData={
             oldPageX:0,
             oldPageY:0,
             gapx:0,
             maxX:(opt.maxX==null)?$(window).width():opt.maxX,
             minX:(opt.minX==null)?-$(window).width():opt.minX,
             me:null,
             clickDist:opt.clickDist || 10,	//distance for judge "click or drag?"
             target:opt.target || null,
             drag:function(e){
               //touchend has no pos Data lol.so,keep the pos data in touchmove event.
               e.preventDefault();
               e=(e.originalEvent.touches&&e.originalEvent.touches[0])||e;
               ddData.lastX = e.pageX;
               ddData.lastY = e.pageY;
               var x = ddData.lastX-ddData.gapx;
               if(x>=ddData.minX && x<=ddData.maxX){
                 ddData.target.css("left",x+"px");
                 ddData.ondrag(e);
               }
             },
             drop:function(e){
               e.preventDefault(); 
               e=(e.originalEvent.touches&&e.originalEvent.touches[0])||e; 
               //unbind events
               $(window)
                 .unbind("mousemove",ddData.drag).unbind("touchmove",ddData.drag)
                 .unbind("mouseup",ddData.drop).unbind("touchend",ddData.drop);
               //calc drag distance, judge "click or drag?"
               var dx=ddData.lastX-ddData.oldPageX;
               var dy=ddData.lastY-ddData.oldPageY;
               var dist=Math.sqrt(dx*dx+dy*dy);
               if(dist<ddData.clickDist){
                 ddData.onclick(e);
               }else{
                 e.direcX = (dx>0)?"right":"left";
                 ddData.ondrop(e);
               } 
             },
             onclick:opt.onclick||function(e){},
             ondown:opt.ondown||function(e){},
             ondrag:opt.ondrag||function(e){},
             ondrop:opt.ondrop||function(e){}			
           };
           return this.each(function(){
             var me = $(this);
             var down = function(e){
               ddData.ondown(e);
               e.preventDefault();
               e=(e.originalEvent.touches&&e.originalEvent.touches[0])||e;
               ddData.me = me;
               ddData.oldPageX = ddData.lastX = e.pageX;
               ddData.oldPageY = ddData.lastY = e.pageY;
               ddData.target = ddData.target || me;
               ddData.gapx = e.pageX-ddData.target.getLeftPx();
               ddData.bindTarget = $(window);
               //bind events
               $(window)
               .bind("mousemove",ddData,ddData.drag).bind("touchmove",ddData,ddData.drag)
               .bind("mouseup",ddData,ddData.drop).bind("touchend",ddData,ddData.drop);
               ddData.drag(e);
             }
             me.bind("touchstart",ddData,down).mousedown(ddData,down);
           });
         }

      });
      //Edge binding end

      Symbol.bindElementAction(compId, symbolName, "document", "compositionReady", function(sym, e) {
         //variables
         var PADDING = 10;
         var PIC_WIDTH = 100;
         var PAD_AND_WIDTH = PADDING+PIC_WIDTH;
         var TOP_PIC_X = -(PIC_WIDTH);
         
         //set carousel base div
         var base = sym.$("carouselBase");
         var BASE_X = parseInt(base.css("left"));
         
         //set picList (pic01-pic08)
         var picList = [];
         $.each($(".pic"),function(i,elm){
         	picList.push(elm);
         });
         var topIndex = picList.length-1;
         
         //func for relocate pics
         function RelocatePics(){
         	var i = 0;
         	while(i<picList.length){
         		$(picList[topIndex]).css("left",TOP_PIC_X+(PADDING+PIC_WIDTH)*i+"px");
         		i++;
         		topIndex = ++topIndex%picList.length;
         	}
         }
         RelocatePics();
         
         //set draggableX to $(".pic")
         $(".pic").draggableX({
         	target:base,
         	ondrag:function(e){
         		var gap = BASE_X - parseInt(base.css("left"));
         		sym.$("log").text("gap:" + gap);
         		//check loop pos
         		if(gap>PAD_AND_WIDTH || gap<-PAD_AND_WIDTH){
         			//relocate pics
         			topIndex +=(gap>0)?1:-1;
         			topIndex = (topIndex+picList.length)%picList.length;
         			RelocatePics();
         			//reset base pos
         			base.css("left",BASE_X+"px");
         			//reset data for draggable
         			var ddData = e.data;
         			ddData.oldPageX = ddData.lastX = e.pageX;
               	ddData.oldPageY = ddData.lastY = e.pageY;
         	      ddData.gapx = e.pageX-ddData.target.getLeftPx();
         		}
         	}
         });

      });
      //Edge binding end

   })("stage");
   //Edge symbol end:'stage'

   //=========================================================
   
   //Edge symbol: 'piyo'
   (function(symbolName) {   
   
      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 240, function(sym, e) {
         sym.play("left");

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 737, function(sym, e) {
         sym.play("right");

      });
      //Edge binding end

      Symbol.bindTriggerAction(compId, symbolName, "Default Timeline", 1079, function(sym, e) {
         sym.play("fwd");

      });
      //Edge binding end

      Symbol.bindSymbolAction(compId, symbolName, "creationComplete", function(sym, e) {
         // シンボルが作成されたときに実行するコードをここに挿入
         
         sym.direc = -1;
         sym.STAGE_WIDTH = 800; //$("#Stage").css("width")
         sym.n = 0;
         sym.elem = sym.getSymbolElement();
         
         sym.startMove = function(){
         	sym.n = setInterval(sym.move,1000/12);
         	sym.turn(sym.direc);
         	return sym;
         };
         
         sym.move = function(){
         	var left = parseInt(sym.elem.css("left"));
         	left = (sym.STAGE_WIDTH + 20*sym.direc + left)%sym.STAGE_WIDTH;
         	sym.elem.css("left",left+"px");
         	return sym;
         };
         
         sym.stopMove = function(){
         	sym.play("fwd");
         	clearInterval(sym.n);
         	return sym;
         };
         
         sym.turn = function(direc){
         	var direc = direc || sym.direc*-1;
         	if(direc>0){
         		sym.play("right");
         	}else{
         		sym.play("left");
         	}
         	sym.direc=direc;
         	return sym;
         };
         
         sym.startMove();

      });
      //Edge binding end

   })("piyo");
   //Edge symbol end:'piyo'

})(jQuery, AdobeEdge, "EDGE-312238482");